(2.10) Add unittests for Hotplug support
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Helper function to strip src/ and test/hs/ from a list
18 strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
19
20 # Use bash in order to be able to use pipefail
21 SHELL=/bin/bash
22
23 ACLOCAL_AMFLAGS = -I autotools
24 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
25 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
26 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
27 CHECK_HEADER = $(top_srcdir)/autotools/check-header
28 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
29 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
30 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
31 CHECK_VERSION = $(top_srcdir)/autotools/check-version
32 CHECK_NEWS = $(top_srcdir)/autotools/check-news
33 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
34 DOCPP = $(top_srcdir)/autotools/docpp
35 REPLACE_VARS_SED = autotools/replace_vars.sed
36 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
37 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
38 SHELL_ENV_INIT = autotools/shell-env-init
39
40 # Note: these are automake-specific variables, and must be named after
41 # the directory + 'dir' suffix
42 clientdir = $(pkgpythondir)/client
43 cmdlibdir = $(pkgpythondir)/cmdlib
44 hypervisordir = $(pkgpythondir)/hypervisor
45 httpdir = $(pkgpythondir)/http
46 masterddir = $(pkgpythondir)/masterd
47 confddir = $(pkgpythondir)/confd
48 rapidir = $(pkgpythondir)/rapi
49 serverdir = $(pkgpythondir)/server
50 watcherdir = $(pkgpythondir)/watcher
51 impexpddir = $(pkgpythondir)/impexpd
52 utilsdir = $(pkgpythondir)/utils
53 toolsdir = $(pkglibdir)/tools
54 iallocatorsdir = $(pkglibdir)/iallocators
55 pytoolsdir = $(pkgpythondir)/tools
56 docdir = $(datadir)/doc/$(PACKAGE)
57 myexeclibdir = $(pkglibdir)
58
59 # Delete output file if an error occurred while building it
60 .DELETE_ON_ERROR:
61
62 HS_DIRS = \
63         src \
64         src/Ganeti \
65         src/Ganeti/Block \
66         src/Ganeti/Block/Drbd \
67         src/Ganeti/Confd \
68         src/Ganeti/Curl \
69         src/Ganeti/DataCollectors \
70         src/Ganeti/HTools \
71         src/Ganeti/HTools/Backend \
72         src/Ganeti/HTools/Program \
73         src/Ganeti/Hypervisor \
74         src/Ganeti/Hypervisor/Xen \
75         src/Ganeti/Monitoring \
76         src/Ganeti/Query \
77         test/hs \
78         test/hs/Test \
79         test/hs/Test/Ganeti \
80         test/hs/Test/Ganeti/Block \
81         test/hs/Test/Ganeti/Block/Drbd \
82         test/hs/Test/Ganeti/Confd \
83         test/hs/Test/Ganeti/HTools \
84         test/hs/Test/Ganeti/HTools/Backend \
85         test/hs/Test/Ganeti/Hypervisor \
86         test/hs/Test/Ganeti/Hypervisor/Xen \
87         test/hs/Test/Ganeti/Query
88
89 # Haskell directories without the roots (src, test/hs)
90 HS_DIRS_NOROOT = $(filter-out src,$(filter-out test/hs,$(HS_DIRS)))
91
92 DIRS = \
93         $(HS_DIRS) \
94         autotools \
95         daemons \
96         devel \
97         devel/data \
98         doc \
99         doc/css \
100         doc/examples \
101         doc/examples/gnt-debug \
102         doc/examples/hooks \
103         doc/users \
104         test/data/htools \
105         test/data/htools/rapi \
106         test/hs/shelltests \
107         test/autotools \
108         lib \
109         lib/build \
110         lib/client \
111         lib/cmdlib \
112         lib/confd \
113         lib/http \
114         lib/hypervisor \
115         lib/impexpd \
116         lib/masterd \
117         lib/rapi \
118         lib/server \
119         lib/tools \
120         lib/utils \
121         lib/watcher \
122         man \
123         qa \
124         qa/patch \
125         test \
126         test/data \
127         test/data/bdev-rbd \
128         test/data/ovfdata \
129         test/data/ovfdata/other \
130         test/py \
131         tools
132
133 ALL_APIDOC_HS_DIRS = \
134         $(APIDOC_HS_DIR) \
135         $(patsubst %,$(APIDOC_HS_DIR)/%,$(call strip_hsroot,$(HS_DIRS_NOROOT)))
136
137 BUILDTIME_DIR_AUTOCREATE = \
138         scripts \
139         $(APIDOC_DIR) \
140         $(ALL_APIDOC_HS_DIRS) \
141         $(APIDOC_PY_DIR) \
142         $(COVERAGE_DIR) \
143         $(COVERAGE_HS_DIR) \
144         $(COVERAGE_PY_DIR) \
145         .hpc
146
147 BUILDTIME_DIRS = \
148         $(BUILDTIME_DIR_AUTOCREATE) \
149         doc/html \
150         doc/man-html
151
152 DIRCHECK_EXCLUDE = \
153         $(BUILDTIME_DIRS) \
154         ganeti-[0-9]*.[0-9]*.[0-9]* \
155         doc/html/_* \
156         doc/man-html/_* \
157         autom4te.cache
158
159 # some helper vars
160 COVERAGE_DIR = doc/coverage
161 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
162 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
163 APIDOC_DIR = doc/api
164 APIDOC_PY_DIR = $(APIDOC_DIR)/py
165 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
166
167 MAINTAINERCLEANFILES = \
168         $(maninput) \
169         doc/install-quick.rst \
170         doc/news.rst \
171         doc/upgrade.rst \
172         vcs-version
173
174 maintainer-clean-local:
175         rm -rf $(BUILDTIME_DIRS)
176
177 CLEANFILES = \
178         $(addsuffix /*.py[co],$(DIRS)) \
179         $(addsuffix /*.hi,$(HS_DIRS)) \
180         $(addsuffix /*.o,$(HS_DIRS)) \
181         $(PYTHON_BOOTSTRAP) \
182         epydoc.conf \
183         $(REPLACE_VARS_SED) \
184         $(SHELL_ENV_INIT) \
185         daemons/daemon-util \
186         daemons/ganeti-cleaner \
187         devel/squeeze-amd64.tar.gz \
188         devel/squeeze-amd64.conf \
189         $(mandocrst) \
190         doc/manpages-enabled.rst \
191         $(BUILT_EXAMPLES) \
192         doc/examples/bash_completion \
193         doc/examples/bash_completion-debug \
194         $(userspecs) \
195         lib/_generated_rpc.py \
196         $(man_MANS) \
197         $(manhtml) \
198         tools/kvm-ifup \
199         tools/vif-ganeti \
200         tools/net-common \
201         tools/users-setup \
202         tools/vcluster-setup \
203         stamp-directories \
204         stamp-srclinks \
205         $(nodist_pkgpython_PYTHON) \
206         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
207         $(HS_BUILT_TEST_HELPERS) \
208         src/ganeti-confd \
209         src/ganeti-luxid \
210         src/ganeti-mond \
211         .hpc/*.mix src/*.tix test/hs/*.tix \
212         doc/hs-lint.html
213
214 GENERATED_FILES = \
215         $(built_base_sources) \
216         $(BUILT_PYTHON_SOURCES) \
217         $(PYTHON_BOOTSTRAP)
218
219 HS_GENERATED_FILES =
220 if WANT_HTOOLS
221 HS_GENERATED_FILES += $(HS_PROGS)
222 if ENABLE_CONFD
223 HS_GENERATED_FILES += src/hconfd src/ganeti-confd src/hluxid src/ganeti-luxid
224 endif
225
226 if ENABLE_MOND
227 HS_GENERATED_FILES += src/ganeti-mond
228 endif
229 endif
230
231 built_base_sources = \
232         stamp-directories \
233         stamp-srclinks
234
235 built_python_base_sources = \
236         lib/_autoconf.py \
237         lib/_vcsversion.py
238
239 BUILT_PYTHON_SOURCES = \
240         $(built_python_base_sources) \
241         lib/_generated_rpc.py
242
243 # Generating the RPC wrappers depends on many things, so make sure
244 # it's built at the end of the built sources
245 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
246
247 # these are all built from the underlying %.in sources
248 BUILT_EXAMPLES = \
249         doc/examples/ganeti-kvm-poweroff.initd \
250         doc/examples/ganeti.cron \
251         doc/examples/ganeti.initd \
252         doc/examples/ganeti.logrotate \
253         doc/examples/ganeti-master-role.ocf \
254         doc/examples/ganeti-node-role.ocf \
255         doc/examples/gnt-config-backup \
256         doc/examples/hooks/ipsec
257
258 nodist_pkgpython_PYTHON = \
259         $(BUILT_PYTHON_SOURCES)
260
261 noinst_PYTHON = \
262         lib/build/__init__.py \
263         lib/build/shell_example_lexer.py \
264         lib/build/sphinx_ext.py
265
266 pkgpython_PYTHON = \
267         lib/__init__.py \
268         lib/asyncnotifier.py \
269         lib/backend.py \
270         lib/bdev.py \
271         lib/bootstrap.py \
272         lib/cli.py \
273         lib/compat.py \
274         lib/config.py \
275         lib/constants.py \
276         lib/daemon.py \
277         lib/errors.py \
278         lib/hooksmaster.py \
279         lib/ht.py \
280         lib/jqueue.py \
281         lib/jstore.py \
282         lib/locking.py \
283         lib/luxi.py \
284         lib/mcpu.py \
285         lib/netutils.py \
286         lib/objects.py \
287         lib/opcodes.py \
288         lib/outils.py \
289         lib/ovf.py \
290         lib/pathutils.py \
291         lib/qlang.py \
292         lib/query.py \
293         lib/rpc.py \
294         lib/rpc_defs.py \
295         lib/runtime.py \
296         lib/serializer.py \
297         lib/ssconf.py \
298         lib/ssh.py \
299         lib/storage.py \
300         lib/uidpool.py \
301         lib/vcluster.py \
302         lib/network.py \
303         lib/workerpool.py
304
305 client_PYTHON = \
306         lib/client/__init__.py \
307         lib/client/gnt_backup.py \
308         lib/client/gnt_cluster.py \
309         lib/client/gnt_debug.py \
310         lib/client/gnt_group.py \
311         lib/client/gnt_instance.py \
312         lib/client/gnt_job.py \
313         lib/client/gnt_node.py \
314         lib/client/gnt_network.py \
315         lib/client/gnt_os.py \
316         lib/client/gnt_storage.py
317
318 cmdlib_PYTHON = \
319         lib/cmdlib/__init__.py \
320         lib/cmdlib/backup.py \
321         lib/cmdlib/base.py \
322         lib/cmdlib/cluster.py \
323         lib/cmdlib/common.py \
324         lib/cmdlib/group.py \
325         lib/cmdlib/instance.py \
326         lib/cmdlib/instance_migration.py \
327         lib/cmdlib/instance_operation.py \
328         lib/cmdlib/instance_query.py \
329         lib/cmdlib/instance_storage.py \
330         lib/cmdlib/instance_utils.py \
331         lib/cmdlib/misc.py \
332         lib/cmdlib/network.py \
333         lib/cmdlib/node.py \
334         lib/cmdlib/operating_system.py \
335         lib/cmdlib/query.py \
336         lib/cmdlib/tags.py \
337         lib/cmdlib/test.py
338
339 hypervisor_PYTHON = \
340         lib/hypervisor/__init__.py \
341         lib/hypervisor/hv_base.py \
342         lib/hypervisor/hv_chroot.py \
343         lib/hypervisor/hv_fake.py \
344         lib/hypervisor/hv_kvm.py \
345         lib/hypervisor/hv_lxc.py \
346         lib/hypervisor/hv_xen.py
347
348 rapi_PYTHON = \
349         lib/rapi/__init__.py \
350         lib/rapi/baserlib.py \
351         lib/rapi/client.py \
352         lib/rapi/client_utils.py \
353         lib/rapi/connector.py \
354         lib/rapi/rlib2.py \
355         lib/rapi/testutils.py
356
357 http_PYTHON = \
358         lib/http/__init__.py \
359         lib/http/auth.py \
360         lib/http/client.py \
361         lib/http/server.py
362
363 confd_PYTHON = \
364         lib/confd/__init__.py \
365         lib/confd/client.py
366
367 masterd_PYTHON = \
368         lib/masterd/__init__.py \
369         lib/masterd/iallocator.py \
370         lib/masterd/instance.py
371
372 impexpd_PYTHON = \
373         lib/impexpd/__init__.py
374
375 watcher_PYTHON = \
376         lib/watcher/__init__.py \
377         lib/watcher/nodemaint.py \
378         lib/watcher/state.py
379
380 server_PYTHON = \
381         lib/server/__init__.py \
382         lib/server/masterd.py \
383         lib/server/noded.py \
384         lib/server/rapi.py
385
386 pytools_PYTHON = \
387         lib/tools/__init__.py \
388         lib/tools/burnin.py \
389         lib/tools/ensure_dirs.py \
390         lib/tools/node_cleanup.py \
391         lib/tools/node_daemon_setup.py \
392         lib/tools/prepare_node_join.py
393
394 utils_PYTHON = \
395         lib/utils/__init__.py \
396         lib/utils/algo.py \
397         lib/utils/filelock.py \
398         lib/utils/hash.py \
399         lib/utils/io.py \
400         lib/utils/log.py \
401         lib/utils/lvm.py \
402         lib/utils/mlock.py \
403         lib/utils/nodesetup.py \
404         lib/utils/process.py \
405         lib/utils/retry.py \
406         lib/utils/text.py \
407         lib/utils/wrapper.py \
408         lib/utils/x509.py
409
410 docinput = \
411         doc/conf.py \
412         doc/css/style.css \
413         doc/admin.rst \
414         doc/cluster-merge.rst \
415         doc/design-2.0.rst \
416         doc/design-2.1.rst \
417         doc/design-2.2.rst \
418         doc/design-2.3.rst \
419         doc/design-2.4.rst \
420         doc/design-2.5.rst \
421         doc/design-2.6.rst \
422         doc/design-2.7.rst \
423         doc/design-2.8.rst \
424         doc/design-autorepair.rst \
425         doc/design-bulk-create.rst \
426         doc/design-chained-jobs.rst \
427         doc/design-cpu-pinning.rst \
428         doc/design-device-uuid-name.rst \
429         doc/design-draft.rst \
430         doc/design-daemons.rst \
431         doc/design-htools-2.3.rst \
432         doc/design-http-server.rst \
433         doc/design-impexp2.rst \
434         doc/design-lu-generated-jobs.rst \
435         doc/design-linuxha.rst \
436         doc/design-multi-reloc.rst \
437         doc/design-network.rst \
438         doc/design-node-add.rst \
439         doc/design-oob.rst \
440         doc/design-ovf-support.rst \
441         doc/design-opportunistic-locking.rst \
442         doc/design-partitioned.rst \
443         doc/design-query-splitting.rst \
444         doc/design-query2.rst \
445         doc/design-reason-trail.rst \
446         doc/design-resource-model.rst \
447         doc/design-restricted-commands.rst \
448         doc/design-shared-storage.rst \
449         doc/design-monitoring-agent.rst \
450         doc/design-virtual-clusters.rst \
451         doc/design-x509-ca.rst \
452         doc/design-hroller.rst \
453         doc/design-storagetypes.rst \
454         doc/devnotes.rst \
455         doc/glossary.rst \
456         doc/hooks.rst \
457         doc/iallocator.rst \
458         doc/index.rst \
459         doc/install-quick.rst \
460         doc/install.rst \
461         doc/locking.rst \
462         doc/manpages-disabled.rst \
463         doc/monitoring-query-format.rst \
464         doc/move-instance.rst \
465         doc/news.rst \
466         doc/ovfconverter.rst \
467         doc/rapi.rst \
468         doc/security.rst \
469         doc/upgrade.rst \
470         doc/virtual-cluster.rst \
471         doc/walkthrough.rst
472
473 # Generates file names such as "doc/man-gnt-instance.rst"
474 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
475
476 # Haskell programs to be installed in $PREFIX/bin
477 HS_BIN_PROGS=src/htools
478
479 # Haskell programs to be installed in the MYEXECLIB dir
480 if ENABLE_MOND
481 HS_MYEXECLIB_PROGS=src/mon-collector
482 else
483 HS_MYEXECLIB_PROGS=
484 endif
485
486 # Haskell programs to be compiled by "make really-all"
487 HS_COMPILE_PROGS= \
488         src/ganeti-mond \
489         src/hconfd \
490         src/hluxid \
491         src/rpc-test
492
493 # All Haskell non-test programs to be compiled but not automatically installed
494 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
495
496 HS_BIN_ROLES = harep hbal hscan hspace hinfo hcheck hroller
497 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
498
499 HS_ALL_PROGS = \
500         $(HS_PROGS) \
501         test/hs/hpc-htools \
502         test/hs/hpc-mon-collector \
503         test/hs/htest \
504         $(HS_COMPILE_PROGS)
505
506 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
507 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
508
509 HFLAGS = \
510         -O -Wall -Werror -isrc \
511         -fwarn-monomorphism-restriction \
512         -fwarn-tabs \
513         $(GHC_BYVERSION_FLAGS)
514
515 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
516 HEXTRA =
517 # internal extra flags (used for test/hs/htest mainly)
518 HEXTRA_INT =
519 # exclude options for coverage reports
520 HPCEXCL = --exclude Main \
521         --exclude Ganeti.Constants \
522         --exclude Ganeti.HTools.QC \
523         --exclude Ganeti.THH \
524         --exclude Ganeti.Version \
525         --exclude Test.Ganeti.Attoparsec \
526         --exclude Test.Ganeti.TestCommon \
527         --exclude Test.Ganeti.TestHTools \
528         --exclude Test.Ganeti.TestHelper \
529         --exclude Test.Ganeti.TestImports \
530         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
531
532 HS_LIB_SRCS = \
533         src/Ganeti/Block/Drbd/Types.hs \
534         src/Ganeti/Block/Drbd/Parser.hs \
535         src/Ganeti/BasicTypes.hs \
536         src/Ganeti/Common.hs \
537         src/Ganeti/Compat.hs \
538         src/Ganeti/Confd/Client.hs \
539         src/Ganeti/Confd/Server.hs \
540         src/Ganeti/Confd/Types.hs \
541         src/Ganeti/Confd/Utils.hs \
542         src/Ganeti/Config.hs \
543         src/Ganeti/ConfigReader.hs \
544         src/Ganeti/Curl/Multi.hs \
545         src/Ganeti/Daemon.hs \
546         src/Ganeti/DataCollectors/CLI.hs \
547         src/Ganeti/DataCollectors/Drbd.hs \
548         src/Ganeti/DataCollectors/Program.hs \
549         src/Ganeti/DataCollectors/Types.hs \
550         src/Ganeti/Errors.hs \
551         src/Ganeti/HTools/Backend/IAlloc.hs \
552         src/Ganeti/HTools/Backend/Luxi.hs \
553         src/Ganeti/HTools/Backend/Rapi.hs \
554         src/Ganeti/HTools/Backend/Simu.hs \
555         src/Ganeti/HTools/Backend/Text.hs \
556         src/Ganeti/HTools/CLI.hs \
557         src/Ganeti/HTools/Cluster.hs \
558         src/Ganeti/HTools/Container.hs \
559         src/Ganeti/HTools/ExtLoader.hs \
560         src/Ganeti/HTools/Graph.hs \
561         src/Ganeti/HTools/Group.hs \
562         src/Ganeti/HTools/Instance.hs \
563         src/Ganeti/HTools/Loader.hs \
564         src/Ganeti/HTools/Nic.hs \
565         src/Ganeti/HTools/Node.hs \
566         src/Ganeti/HTools/PeerMap.hs \
567         src/Ganeti/HTools/Program/Hail.hs \
568         src/Ganeti/HTools/Program/Harep.hs \
569         src/Ganeti/HTools/Program/Hbal.hs \
570         src/Ganeti/HTools/Program/Hcheck.hs \
571         src/Ganeti/HTools/Program/Hinfo.hs \
572         src/Ganeti/HTools/Program/Hscan.hs \
573         src/Ganeti/HTools/Program/Hspace.hs \
574         src/Ganeti/HTools/Program/Hroller.hs \
575         src/Ganeti/HTools/Program/Main.hs \
576         src/Ganeti/HTools/Types.hs \
577         src/Ganeti/Hypervisor/Xen/XmParser.hs \
578         src/Ganeti/Hypervisor/Xen/Types.hs \
579         src/Ganeti/Hash.hs \
580         src/Ganeti/JQueue.hs \
581         src/Ganeti/JSON.hs \
582         src/Ganeti/Jobs.hs \
583         src/Ganeti/Logging.hs \
584         src/Ganeti/Luxi.hs \
585         src/Ganeti/Monitoring/Server.hs \
586         src/Ganeti/Network.hs \
587         src/Ganeti/Objects.hs \
588         src/Ganeti/OpCodes.hs \
589         src/Ganeti/OpParams.hs \
590         src/Ganeti/Path.hs \
591         src/Ganeti/Query/Common.hs \
592         src/Ganeti/Query/Export.hs \
593         src/Ganeti/Query/Filter.hs \
594         src/Ganeti/Query/Group.hs \
595         src/Ganeti/Query/Job.hs \
596         src/Ganeti/Query/Language.hs \
597         src/Ganeti/Query/Network.hs \
598         src/Ganeti/Query/Node.hs \
599         src/Ganeti/Query/Query.hs \
600         src/Ganeti/Query/Server.hs \
601         src/Ganeti/Query/Types.hs \
602         src/Ganeti/Rpc.hs \
603         src/Ganeti/Runtime.hs \
604         src/Ganeti/Ssconf.hs \
605         src/Ganeti/THH.hs \
606         src/Ganeti/Types.hs \
607         src/Ganeti/Utils.hs
608
609 HS_TEST_SRCS = \
610         test/hs/Test/Ganeti/Attoparsec.hs \
611         test/hs/Test/Ganeti/BasicTypes.hs \
612         test/hs/Test/Ganeti/Block/Drbd/Parser.hs \
613         test/hs/Test/Ganeti/Block/Drbd/Types.hs \
614         test/hs/Test/Ganeti/Common.hs \
615         test/hs/Test/Ganeti/Confd/Types.hs \
616         test/hs/Test/Ganeti/Confd/Utils.hs \
617         test/hs/Test/Ganeti/Daemon.hs \
618         test/hs/Test/Ganeti/Errors.hs \
619         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
620         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
621         test/hs/Test/Ganeti/HTools/CLI.hs \
622         test/hs/Test/Ganeti/HTools/Cluster.hs \
623         test/hs/Test/Ganeti/HTools/Container.hs \
624         test/hs/Test/Ganeti/HTools/Graph.hs \
625         test/hs/Test/Ganeti/HTools/Instance.hs \
626         test/hs/Test/Ganeti/HTools/Loader.hs \
627         test/hs/Test/Ganeti/HTools/Node.hs \
628         test/hs/Test/Ganeti/HTools/PeerMap.hs \
629         test/hs/Test/Ganeti/HTools/Types.hs \
630         test/hs/Test/Ganeti/Hypervisor/Xen/XmParser.hs \
631         test/hs/Test/Ganeti/JSON.hs \
632         test/hs/Test/Ganeti/Jobs.hs \
633         test/hs/Test/Ganeti/JQueue.hs \
634         test/hs/Test/Ganeti/Luxi.hs \
635         test/hs/Test/Ganeti/Network.hs \
636         test/hs/Test/Ganeti/Objects.hs \
637         test/hs/Test/Ganeti/OpCodes.hs \
638         test/hs/Test/Ganeti/Query/Filter.hs \
639         test/hs/Test/Ganeti/Query/Language.hs \
640         test/hs/Test/Ganeti/Query/Network.hs \
641         test/hs/Test/Ganeti/Query/Query.hs \
642         test/hs/Test/Ganeti/Rpc.hs \
643         test/hs/Test/Ganeti/Runtime.hs \
644         test/hs/Test/Ganeti/Ssconf.hs \
645         test/hs/Test/Ganeti/THH.hs \
646         test/hs/Test/Ganeti/TestCommon.hs \
647         test/hs/Test/Ganeti/TestHTools.hs \
648         test/hs/Test/Ganeti/TestHelper.hs \
649         test/hs/Test/Ganeti/Types.hs \
650         test/hs/Test/Ganeti/Utils.hs
651
652 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
653
654 HS_BUILT_SRCS = \
655         test/hs/Test/Ganeti/TestImports.hs \
656         src/Ganeti/Constants.hs \
657         src/Ganeti/Curl/Internal.hs \
658         src/Ganeti/Version.hs
659 HS_BUILT_SRCS_IN = \
660         $(patsubst %,%.in,$(filter-out src/Ganeti/Curl/Internal.hs,$(HS_BUILT_SRCS))) \
661         src/Ganeti/Curl/Internal.hsc
662
663 HS_LIBTESTBUILT_SRCS = $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS)
664
665 $(RUN_IN_TEMPDIR): | stamp-directories
666
667 doc/html/index.html: ENABLE_MANPAGES =
668 doc/man-html/index.html: ENABLE_MANPAGES = 1
669 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
670
671 # Note: we use here an order-only prerequisite, as the contents of
672 # _autoconf.py are not actually influencing the html build output: it
673 # has to exist in order for the sphinx module to be loaded
674 # successfully, but we certainly don't want the docs to be rebuilt if
675 # it changes
676 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
677         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
678         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
679         doc/css/style.css lib/rapi/connector.py lib/rapi/rlib2.py \
680         | $(BUILT_PYTHON_SOURCES)
681         @test -n "$(SPHINX)" || \
682             { echo 'sphinx-build' not found during configure; exit 1; }
683 if !MANPAGES_IN_DOC
684         if test -n '$(ENABLE_MANPAGES)'; then \
685           echo 'Man pages in documentation were disabled at configure time' >&2; \
686           exit 1; \
687         fi
688 endif
689 ## Sphinx provides little control over what content should be included. Some
690 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
691 ## build two different versions of the documentation--once without man pages and
692 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
693 ## us with this, but requires running in a temporary directory. It moves the
694 ## correct files into place depending on environment variables.
695         dir=$(dir $@) && \
696         @mkdir_p@ $$dir && \
697         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
698         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
699             -d . \
700             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
701             -D release="$(PACKAGE_VERSION)" \
702             -D graphviz_dot="$(DOT)" \
703             -D enable_manpages="$(ENABLE_MANPAGES)" \
704             doc $(CURDIR)/$$dir && \
705         rm -f $$dir/.buildinfo $$dir/objects.inv
706         touch $@
707
708 doc/html: doc/html/index.html
709
710 doc/man-html: doc/man-html/index.html
711
712 doc/install-quick.rst: INSTALL
713 doc/news.rst: NEWS
714 doc/upgrade.rst: UPGRADE
715
716 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
717         set -e; \
718         { echo '.. This file is automatically updated at build time from $<.'; \
719           echo '.. Do not edit.'; \
720           echo; \
721           cat $<; \
722         } > $@
723
724 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
725         { echo '.. This file is automatically generated, do not edit!'; \
726           echo ''; \
727           echo 'Man pages'; \
728           echo '========='; \
729           echo; \
730           echo '.. toctree::'; \
731           echo '   :maxdepth: 1'; \
732           echo; \
733           for i in $(notdir $(mandocrst)); do \
734             echo "   $$i"; \
735           done | LC_ALL=C sort; \
736         } > $@
737
738 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
739 if MANPAGES_IN_DOC
740         { echo '.. This file is automatically updated at build time from $<.'; \
741           echo '.. Do not edit.'; \
742           echo; \
743           echo "$*"; \
744           echo '=========================================='; \
745           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
746         } > $@
747 else
748         echo 'Man pages in documentation were disabled at configure time' >&2; \
749         exit 1;
750 endif
751
752 doc/users/%: doc/users/%.in Makefile $(REPLACE_VARS_SED)
753         cat $< | sed -f $(REPLACE_VARS_SED) | LC_ALL=C sort | uniq | (grep -v '^root' || true) > $@
754
755 userspecs = \
756         doc/users/users \
757         doc/users/groups \
758         doc/users/groupmemberships
759
760 # Things to build but not to install (add it to EXTRA_DIST if it should be
761 # distributed)
762 noinst_DATA = \
763         $(BUILT_EXAMPLES) \
764         doc/examples/bash_completion \
765         doc/examples/bash_completion-debug \
766         $(userspecs) \
767         $(manhtml)
768
769 if HAS_SPHINX
770 if MANPAGES_IN_DOC
771 noinst_DATA += doc/man-html
772 else
773 noinst_DATA += doc/html
774 endif
775 endif
776
777 gnt_scripts = \
778         scripts/gnt-backup \
779         scripts/gnt-cluster \
780         scripts/gnt-debug \
781         scripts/gnt-group \
782         scripts/gnt-instance \
783         scripts/gnt-job \
784         scripts/gnt-network \
785         scripts/gnt-node \
786         scripts/gnt-os \
787         scripts/gnt-storage
788
789 PYTHON_BOOTSTRAP_SBIN = \
790         daemons/ganeti-masterd \
791         daemons/ganeti-noded \
792         daemons/ganeti-rapi \
793         daemons/ganeti-watcher \
794         $(gnt_scripts)
795
796 PYTHON_BOOTSTRAP = \
797         $(PYTHON_BOOTSTRAP_SBIN) \
798         tools/burnin \
799         tools/ensure-dirs \
800         tools/node-cleanup \
801         tools/node-daemon-setup \
802         tools/prepare-node-join
803
804 qa_scripts = \
805         qa/__init__.py \
806         qa/ganeti-qa.py \
807         qa/qa_cluster.py \
808         qa/qa_config.py \
809         qa/qa_daemon.py \
810         qa/qa_env.py \
811         qa/qa_error.py \
812         qa/qa_group.py \
813         qa/qa_instance.py \
814         qa/qa_job.py \
815   qa/qa_logging.py \
816         qa/qa_node.py \
817         qa/qa_os.py \
818         qa/qa_rapi.py \
819         qa/qa_tags.py \
820         qa/qa_utils.py
821
822 bin_SCRIPTS =
823 if WANT_HTOOLS
824 bin_SCRIPTS += $(HS_BIN_PROGS)
825 install-exec-hook:
826         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
827 # FIXME: this is a hardcoded logic, instead of auto-resolving
828         $(LN_S) -f ../../../bin/htools \
829           $(DESTDIR)$(iallocatorsdir)/hail
830         for role in $(HS_BIN_ROLES); do \
831           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
832         done
833 endif
834
835 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTESTBUILT_SRCS) Makefile
836         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
837           echo "Error: cannot run unittests without the development" \
838                " libraries (see devnotes.rst)" 1>&2; \
839           exit 1; \
840         fi
841         @rm -f $(notdir $@).tix
842         $(GHC) --make \
843           $(HFLAGS) \
844           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
845           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
846           $(HEXTRA) $(HEXTRA_INT) $@
847         @touch "$@"
848
849 # for the test/hs/htest binary, we need to enable profiling/coverage
850 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
851
852 # we compile the hpc-htools binary with the program coverage
853 test/hs/hpc-htools: HEXTRA_INT=-fhpc
854
855 # we compile the hpc-mon-collector binary with the program coverage
856 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
857
858 # test dependency
859 test/hs/offline-test.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
860
861 # rules for building profiling-enabled versions of the haskell
862 # programs: hs-prof does the full two-step build, whereas
863 # hs-prof-quick does only the final rebuild (hs-prof must have been
864 # run before)
865 .PHONY: hs-prof hs-prof-quick
866 hs-prof:
867         @if [ -z "$(TARGET)" ]; then \
868           echo "You need to define TARGET when running this rule" 1>&2; \
869           exit 1; \
870         fi
871         $(MAKE) $(AM_MAKEFLAGS) clean
872         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
873         rm -f $(HS_ALL_PROGS)
874         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
875
876 hs-prof-quick:
877         @if [ -z "$(TARGET)" ]; then \
878           echo "You need to define TARGET when running this rule" 1>&2; \
879           exit 1; \
880         fi
881         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
882
883 dist_sbin_SCRIPTS = \
884         tools/ganeti-listrunner
885
886 nodist_sbin_SCRIPTS = \
887         $(PYTHON_BOOTSTRAP_SBIN) \
888         daemons/ganeti-cleaner
889
890 if ENABLE_CONFD
891 src/ganeti-confd: src/hconfd
892         cp -f $< $@
893
894 src/ganeti-luxid: src/hluxid
895         cp -f $< $@
896
897 nodist_sbin_SCRIPTS += src/ganeti-confd
898 nodist_sbin_SCRIPTS += src/ganeti-luxid
899 endif
900
901 if ENABLE_MOND
902 nodist_sbin_SCRIPTS += src/ganeti-mond
903 endif
904
905 python_scripts = \
906         tools/cfgshell \
907         tools/cfgupgrade \
908         tools/cfgupgrade12 \
909         tools/cluster-merge \
910         tools/confd-client \
911         tools/fmtjson \
912         tools/lvmstrap \
913         tools/move-instance \
914         tools/ovfconverter \
915         tools/sanitize-config
916
917 dist_tools_SCRIPTS = \
918         $(python_scripts) \
919         tools/burnin \
920         tools/kvm-console-wrapper \
921         tools/master-ip-setup \
922         tools/xen-console-wrapper
923
924 nodist_tools_python_scripts = \
925         tools/node-cleanup
926
927 nodist_tools_SCRIPTS = \
928         $(nodist_tools_python_scripts) \
929         tools/users-setup \
930         tools/vcluster-setup
931
932 pkglib_python_scripts = \
933         daemons/import-export \
934         tools/check-cert-expired
935
936 nodist_pkglib_python_scripts = \
937         tools/ensure-dirs \
938         tools/node-daemon-setup \
939         tools/prepare-node-join
940
941 myexeclib_SCRIPTS = \
942         daemons/daemon-util \
943         tools/kvm-ifup \
944         tools/vif-ganeti \
945         tools/net-common \
946         $(pkglib_python_scripts) \
947         $(HS_MYEXECLIB_PROGS)
948
949 nodist_myexeclib_SCRIPTS = \
950         $(nodist_pkglib_python_scripts)
951
952 EXTRA_DIST = \
953         NEWS \
954         UPGRADE \
955         epydoc.conf.in \
956         pylintrc \
957         autotools/build-bash-completion \
958         autotools/build-rpc \
959         autotools/check-header \
960         autotools/check-imports \
961         autotools/check-man-dashes \
962         autotools/check-man-references \
963         autotools/check-man-warnings \
964         autotools/check-news \
965         autotools/check-python-code \
966         autotools/check-tar \
967         autotools/check-version \
968         autotools/convert-constants \
969         autotools/docpp \
970         autotools/gen-py-coverage \
971         autotools/sphinx-wrapper \
972         autotools/testrunner \
973         autotools/wrong-hardcoded-paths \
974         $(RUN_IN_TEMPDIR) \
975         daemons/daemon-util.in \
976         daemons/ganeti-cleaner.in \
977         $(pkglib_python_scripts) \
978         devel/upload \
979         devel/webserver \
980         tools/kvm-ifup.in \
981         tools/vif-ganeti.in \
982         tools/net-common.in \
983         tools/vcluster-setup.in \
984         $(docinput) \
985         doc/html \
986         $(BUILT_EXAMPLES:%=%.in) \
987         doc/examples/ganeti.default \
988         doc/examples/ganeti.default-debug \
989         doc/examples/hooks/ethers \
990         doc/examples/gnt-debug/README \
991         doc/examples/gnt-debug/delay0.json \
992         doc/examples/gnt-debug/delay50.json \
993         doc/users/groupmemberships.in \
994         doc/users/groups.in \
995         doc/users/users.in \
996         test/py/lockperf.py \
997         test/py/testutils.py \
998         test/py/mocks.py \
999         $(dist_TESTS) \
1000         $(TEST_FILES) \
1001         man/footer.rst \
1002         $(manrst) \
1003         $(maninput) \
1004         qa/qa-sample.json \
1005         $(qa_scripts) \
1006         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
1007         $(HS_PROG_SRCS) \
1008         src/lint-hints.hs \
1009         test/hs/cli-tests-defs.sh \
1010         test/hs/offline-test.sh \
1011         .ghci
1012
1013 man_MANS = \
1014         man/ganeti-cleaner.8 \
1015         man/ganeti-confd.8 \
1016         man/ganeti-luxid.8 \
1017         man/ganeti-listrunner.8 \
1018         man/ganeti-masterd.8 \
1019         man/ganeti-mond.8 \
1020         man/ganeti-noded.8 \
1021         man/ganeti-os-interface.7 \
1022         man/ganeti-extstorage-interface.7 \
1023         man/ganeti-rapi.8 \
1024         man/ganeti-watcher.8 \
1025         man/ganeti.7 \
1026         man/gnt-backup.8 \
1027         man/gnt-cluster.8 \
1028         man/gnt-debug.8 \
1029         man/gnt-group.8 \
1030         man/gnt-network.8 \
1031         man/gnt-instance.8 \
1032         man/gnt-job.8 \
1033         man/gnt-node.8 \
1034         man/gnt-os.8 \
1035         man/gnt-storage.8 \
1036         man/hail.1 \
1037         man/harep.1 \
1038         man/hbal.1 \
1039         man/hcheck.1 \
1040         man/hinfo.1 \
1041         man/hscan.1 \
1042         man/hspace.1 \
1043         man/hroller.1 \
1044         man/htools.1 \
1045         man/mon-collector.7
1046
1047 # Remove extensions from all filenames in man_MANS
1048 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
1049
1050 manrst = $(patsubst %,%.rst,$(mannoext))
1051 manhtml = $(patsubst %.rst,%.html,$(manrst))
1052 mangen = $(patsubst %.rst,%.gen,$(manrst))
1053 maninput = \
1054         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
1055         $(patsubst %.html,%.html.in,$(manhtml)) \
1056         $(mangen)
1057
1058 TEST_FILES = \
1059         test/autotools/autotools-check-news.test \
1060         test/data/htools/clean-nonzero-score.data \
1061         test/data/htools/common-suffix.data \
1062         test/data/htools/empty-cluster.data \
1063         test/data/htools/hail-alloc-drbd.json \
1064         test/data/htools/hail-alloc-invalid-network.json \
1065         test/data/htools/hail-alloc-invalid-twodisks.json \
1066         test/data/htools/hail-alloc-restricted-network.json \
1067         test/data/htools/hail-alloc-twodisks.json \
1068         test/data/htools/hail-change-group.json \
1069         test/data/htools/hail-invalid-reloc.json \
1070         test/data/htools/hail-node-evac.json \
1071         test/data/htools/hail-reloc-drbd.json \
1072         test/data/htools/hbal-excl-tags.data \
1073         test/data/htools/hbal-split-insts.data \
1074         test/data/htools/hspace-tiered-dualspec.data \
1075         test/data/htools/hspace-tiered-ipolicy.data \
1076         test/data/htools/hspace-tiered-resourcetypes.data \
1077         test/data/htools/hspace-tiered.data \
1078         test/data/htools/invalid-node.data \
1079         test/data/htools/missing-resources.data \
1080         test/data/htools/multiple-master.data \
1081         test/data/htools/n1-failure.data \
1082         test/data/htools/rapi/groups.json \
1083         test/data/htools/rapi/info.json \
1084         test/data/htools/rapi/instances.json \
1085         test/data/htools/rapi/nodes.json \
1086         test/data/htools/unique-reboot-order.data \
1087         test/hs/shelltests/htools-balancing.test \
1088         test/hs/shelltests/htools-basic.test \
1089         test/hs/shelltests/htools-dynutil.test \
1090         test/hs/shelltests/htools-excl.test \
1091         test/hs/shelltests/htools-hail.test \
1092         test/hs/shelltests/htools-hroller.test \
1093         test/hs/shelltests/htools-hspace.test \
1094         test/hs/shelltests/htools-invalid.test \
1095         test/hs/shelltests/htools-multi-group.test \
1096         test/hs/shelltests/htools-no-backend.test \
1097         test/hs/shelltests/htools-rapi.test \
1098         test/hs/shelltests/htools-single-group.test \
1099         test/hs/shelltests/htools-text-backend.test \
1100         test/hs/shelltests/htools-mon-collector.test \
1101         test/data/bdev-drbd-8.0.txt \
1102         test/data/bdev-drbd-8.3.txt \
1103         test/data/bdev-drbd-disk.txt \
1104         test/data/bdev-drbd-net-ip4.txt \
1105         test/data/bdev-drbd-net-ip6.txt \
1106         test/data/bdev-rbd/json_output_empty.txt \
1107         test/data/bdev-rbd/json_output_extra_matches.txt \
1108         test/data/bdev-rbd/json_output_no_matches.txt \
1109         test/data/bdev-rbd/json_output_ok.txt \
1110         test/data/bdev-rbd/plain_output_new_extra_matches.txt \
1111         test/data/bdev-rbd/plain_output_new_no_matches.txt \
1112         test/data/bdev-rbd/plain_output_new_ok.txt \
1113         test/data/bdev-rbd/plain_output_old_empty.txt \
1114         test/data/bdev-rbd/plain_output_old_extra_matches.txt \
1115         test/data/bdev-rbd/plain_output_old_no_matches.txt \
1116         test/data/bdev-rbd/plain_output_old_ok.txt \
1117         test/data/bdev-rbd/output_invalid.txt \
1118         test/data/cert1.pem \
1119         test/data/cert2.pem \
1120         test/data/cluster_config_2.7.json \
1121         test/data/cluster_config_downgraded_2.7.json \
1122         test/data/instance-minor-pairing.txt \
1123         test/data/ip-addr-show-dummy0.txt \
1124         test/data/ip-addr-show-lo-ipv4.txt \
1125         test/data/ip-addr-show-lo-ipv6.txt \
1126         test/data/ip-addr-show-lo-oneline-ipv4.txt \
1127         test/data/ip-addr-show-lo-oneline-ipv6.txt \
1128         test/data/ip-addr-show-lo-oneline.txt \
1129         test/data/ip-addr-show-lo.txt \
1130         test/data/kvm_0.12.5_help.txt \
1131         test/data/kvm_0.15.90_help.txt \
1132         test/data/kvm_0.9.1_help.txt \
1133         test/data/kvm_0.9.1_help_boot_test.txt \
1134         test/data/kvm_1.0_help.txt \
1135         test/data/kvm_1.1.2_help.txt \
1136         test/data/kvm_runtime.json \
1137         test/data/NEWS_OK.txt \
1138         test/data/NEWS_previous_unreleased.txt \
1139         test/data/ovfdata/compr_disk.vmdk.gz \
1140         test/data/ovfdata/config.ini \
1141         test/data/ovfdata/corrupted_resources.ovf \
1142         test/data/ovfdata/empty.ini \
1143         test/data/ovfdata/empty.ovf \
1144         test/data/ovfdata/ganeti.mf \
1145         test/data/ovfdata/ganeti.ovf \
1146         test/data/ovfdata/gzip_disk.ovf \
1147         test/data/ovfdata/new_disk.vmdk \
1148         test/data/ovfdata/no_disk.ini \
1149         test/data/ovfdata/no_disk_in_ref.ovf \
1150         test/data/ovfdata/no_os.ini \
1151         test/data/ovfdata/no_ovf.ova \
1152         test/data/ovfdata/other/rawdisk.raw \
1153         test/data/ovfdata/ova.ova \
1154         test/data/ovfdata/rawdisk.raw \
1155         test/data/ovfdata/second_disk.vmdk \
1156         test/data/ovfdata/unsafe_path.ini \
1157         test/data/ovfdata/virtualbox.ovf \
1158         test/data/ovfdata/wrong_config.ini \
1159         test/data/ovfdata/wrong_extension.ovd \
1160         test/data/ovfdata/wrong_manifest.mf \
1161         test/data/ovfdata/wrong_manifest.ovf \
1162         test/data/ovfdata/wrong_ova.ova \
1163         test/data/ovfdata/wrong_xml.ovf \
1164         test/data/proc_drbd8.txt \
1165         test/data/proc_drbd80-emptyline.txt \
1166         test/data/proc_drbd83.txt \
1167         test/data/proc_drbd83_sync.txt \
1168         test/data/proc_drbd83_sync_want.txt \
1169         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1170         test/data/proc_meminfo.txt \
1171         test/data/proc_cpuinfo.txt \
1172         test/data/qa-minimal-nodes-instances-only.json \
1173         test/data/sys_drbd_usermode_helper.txt \
1174         test/data/vgreduce-removemissing-2.02.02.txt \
1175         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1176         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1177         test/data/vgs-missing-pvs-2.02.02.txt \
1178         test/data/vgs-missing-pvs-2.02.66.txt \
1179         test/data/xen-xm-info-4.0.1.txt \
1180         test/data/xen-xm-list-4.0.1-dom0-only.txt \
1181         test/data/xen-xm-list-4.0.1-four-instances.txt \
1182         test/data/xen-xm-list-long-4.0.1.txt \
1183         test/data/xen-xm-uptime-4.0.1.txt \
1184         test/py/ganeti-cli.test \
1185         test/py/gnt-cli.test \
1186         test/py/import-export_unittest-helper
1187
1188
1189 python_tests = \
1190         doc/examples/rapi_testutils.py \
1191         test/py/cfgupgrade_unittest.py \
1192         test/py/docs_unittest.py \
1193         test/py/ganeti.asyncnotifier_unittest.py \
1194         test/py/ganeti.backend_unittest-runasroot.py \
1195         test/py/ganeti.backend_unittest.py \
1196         test/py/ganeti.bdev_unittest.py \
1197         test/py/ganeti.cli_unittest.py \
1198         test/py/ganeti.client.gnt_cluster_unittest.py \
1199         test/py/ganeti.client.gnt_instance_unittest.py \
1200         test/py/ganeti.client.gnt_job_unittest.py \
1201         test/py/ganeti.cmdlib_unittest.py \
1202         test/py/ganeti.compat_unittest.py \
1203         test/py/ganeti.confd.client_unittest.py \
1204         test/py/ganeti.config_unittest.py \
1205         test/py/ganeti.constants_unittest.py \
1206         test/py/ganeti.daemon_unittest.py \
1207         test/py/ganeti.errors_unittest.py \
1208         test/py/ganeti.hooks_unittest.py \
1209         test/py/ganeti.ht_unittest.py \
1210         test/py/ganeti.http_unittest.py \
1211         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1212         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1213         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1214         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1215         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1216         test/py/ganeti.hypervisor_unittest.py \
1217         test/py/ganeti.impexpd_unittest.py \
1218         test/py/ganeti.jqueue_unittest.py \
1219         test/py/ganeti.jstore_unittest.py \
1220         test/py/ganeti.locking_unittest.py \
1221         test/py/ganeti.luxi_unittest.py \
1222         test/py/ganeti.masterd.iallocator_unittest.py \
1223         test/py/ganeti.masterd.instance_unittest.py \
1224         test/py/ganeti.mcpu_unittest.py \
1225         test/py/ganeti.netutils_unittest.py \
1226         test/py/ganeti.objects_unittest.py \
1227         test/py/ganeti.opcodes_unittest.py \
1228         test/py/ganeti.outils_unittest.py \
1229         test/py/ganeti.ovf_unittest.py \
1230         test/py/ganeti.qlang_unittest.py \
1231         test/py/ganeti.query_unittest.py \
1232         test/py/ganeti.rapi.baserlib_unittest.py \
1233         test/py/ganeti.rapi.client_unittest.py \
1234         test/py/ganeti.rapi.resources_unittest.py \
1235         test/py/ganeti.rapi.rlib2_unittest.py \
1236         test/py/ganeti.rapi.testutils_unittest.py \
1237         test/py/ganeti.rpc_unittest.py \
1238         test/py/ganeti.runtime_unittest.py \
1239         test/py/ganeti.serializer_unittest.py \
1240         test/py/ganeti.server.rapi_unittest.py \
1241         test/py/ganeti.ssconf_unittest.py \
1242         test/py/ganeti.ssh_unittest.py \
1243         test/py/ganeti.storage_unittest.py \
1244         test/py/ganeti.tools.burnin_unittest.py \
1245         test/py/ganeti.tools.ensure_dirs_unittest.py \
1246         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1247         test/py/ganeti.tools.prepare_node_join_unittest.py \
1248         test/py/ganeti.uidpool_unittest.py \
1249         test/py/ganeti.utils.algo_unittest.py \
1250         test/py/ganeti.utils.filelock_unittest.py \
1251         test/py/ganeti.utils.hash_unittest.py \
1252         test/py/ganeti.utils.io_unittest-runasroot.py \
1253         test/py/ganeti.utils.io_unittest.py \
1254         test/py/ganeti.utils.log_unittest.py \
1255         test/py/ganeti.utils.lvm_unittest.py \
1256         test/py/ganeti.utils.mlock_unittest.py \
1257         test/py/ganeti.utils.nodesetup_unittest.py \
1258         test/py/ganeti.utils.process_unittest.py \
1259         test/py/ganeti.utils.retry_unittest.py \
1260         test/py/ganeti.utils.text_unittest.py \
1261         test/py/ganeti.utils.wrapper_unittest.py \
1262         test/py/ganeti.utils.x509_unittest.py \
1263         test/py/ganeti.utils_unittest.py \
1264         test/py/ganeti.vcluster_unittest.py \
1265         test/py/ganeti.workerpool_unittest.py \
1266         test/py/pycurl_reset_unittest.py \
1267         test/py/qa.qa_config_unittest.py \
1268         test/py/tempfile_fork_unittest.py
1269
1270 haskell_tests = test/hs/htest
1271
1272 dist_TESTS = \
1273         test/py/check-cert-expired_unittest.bash \
1274         test/py/daemon-util_unittest.bash \
1275         test/py/ganeti-cleaner_unittest.bash \
1276         test/py/import-export_unittest.bash \
1277         test/py/cli-test.bash \
1278         test/py/bash_completion.bash
1279
1280 if PY_UNIT
1281 dist_TESTS += $(python_tests)
1282 endif
1283
1284 nodist_TESTS =
1285 check_SCRIPTS =
1286
1287 if WANT_HSTESTS
1288 nodist_TESTS += $(haskell_tests)
1289 dist_TESTS += test/hs/offline-test.sh
1290 check_SCRIPTS += \
1291         test/hs/hpc-htools \
1292         test/hs/hpc-mon-collector \
1293         $(HS_BUILT_TEST_HELPERS)
1294 endif
1295
1296 TESTS = $(dist_TESTS) $(nodist_TESTS)
1297
1298 # Environment for all tests
1299 PLAIN_TESTS_ENVIRONMENT = \
1300         PYTHONPATH=. \
1301         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1302         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1303         $(RUN_IN_TEMPDIR)
1304
1305 # Environment for tests run by automake
1306 TESTS_ENVIRONMENT = \
1307         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1308
1309 all_python_code = \
1310         $(dist_sbin_SCRIPTS) \
1311         $(python_scripts) \
1312         $(pkglib_python_scripts) \
1313         $(nodist_pkglib_python_scripts) \
1314         $(nodist_tools_python_scripts) \
1315         $(pkgpython_PYTHON) \
1316         $(client_PYTHON) \
1317         $(cmdlib_PYTHON) \
1318         $(hypervisor_PYTHON) \
1319         $(rapi_PYTHON) \
1320         $(server_PYTHON) \
1321         $(pytools_PYTHON) \
1322         $(http_PYTHON) \
1323         $(confd_PYTHON) \
1324         $(masterd_PYTHON) \
1325         $(impexpd_PYTHON) \
1326         $(utils_PYTHON) \
1327         $(watcher_PYTHON) \
1328         $(noinst_PYTHON) \
1329         $(qa_scripts)
1330
1331 if PY_UNIT
1332 all_python_code += $(python_tests)
1333 endif
1334
1335 srclink_files = \
1336         man/footer.rst \
1337         test/py/check-cert-expired_unittest.bash \
1338         test/py/daemon-util_unittest.bash \
1339         test/py/ganeti-cleaner_unittest.bash \
1340         test/py/import-export_unittest.bash \
1341         test/py/cli-test.bash \
1342         test/py/bash_completion.bash \
1343         test/hs/offline-test.sh \
1344         test/hs/cli-tests-defs.sh \
1345         $(all_python_code) \
1346         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1347         $(docinput)
1348
1349 check_python_code = \
1350         $(BUILD_BASH_COMPLETION) \
1351         $(CHECK_IMPORTS) \
1352         $(CHECK_HEADER) \
1353         $(DOCPP) \
1354         $(all_python_code)
1355
1356 lint_python_code = \
1357         ganeti \
1358         ganeti/http/server.py \
1359         $(dist_sbin_SCRIPTS) \
1360         $(python_scripts) \
1361         $(pkglib_python_scripts) \
1362         $(BUILD_BASH_COMPLETION) \
1363         $(CHECK_IMPORTS) \
1364         $(CHECK_HEADER) \
1365         $(DOCPP) \
1366         $(PYTHON_BOOTSTRAP)
1367
1368 standalone_python_modules = \
1369         lib/rapi/client.py \
1370         tools/ganeti-listrunner
1371
1372 pep8_python_code = \
1373         ganeti \
1374         ganeti/http/server.py \
1375         $(dist_sbin_SCRIPTS) \
1376         $(python_scripts) \
1377         $(pkglib_python_scripts) \
1378         $(BUILD_BASH_COMPLETION) \
1379         $(CHECK_HEADER) \
1380         $(DOCPP) \
1381         $(PYTHON_BOOTSTRAP) \
1382         qa
1383
1384 test/py/daemon-util_unittest.bash: daemons/daemon-util
1385
1386 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1387
1388 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1389
1390 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1391         sed -f $(REPLACE_VARS_SED) < $< > $@
1392         chmod +x $@
1393
1394 tools/vif-ganeti: tools/vif-ganeti.in $(REPLACE_VARS_SED)
1395         sed -f $(REPLACE_VARS_SED) < $< > $@
1396         chmod +x $@
1397
1398 tools/net-common: tools/net-common.in $(REPLACE_VARS_SED)
1399         sed -f $(REPLACE_VARS_SED) < $< > $@
1400         chmod +x $@
1401
1402 tools/users-setup: Makefile $(userspecs)
1403         set -e; \
1404         { echo '#!/bin/sh'; \
1405           echo 'if [ "x$$1" != "x--yes-do-it" ];'; \
1406           echo 'then echo "This will do the following changes"'; \
1407           $(AWK) -- '{print "echo + Will add group ",$$1; count++}\
1408                      END {if (count == 0) {print "echo + No groups to add"}}' doc/users/groups; \
1409           $(AWK) -- '{if (NF > 1) {print "echo + Will add user",$$1,"with primary group",$$2} \
1410                                   else {print "echo + Will add user",$$1}; count++}\
1411                      END {if (count == 0) {print "echo + No users to add"}}' doc/users/users; \
1412           $(AWK) -- '{print "echo + Will add user",$$1,"to group",$$2}' doc/users/groupmemberships; \
1413           echo 'echo'; \
1414           echo 'echo "OK? (y/n)"'; \
1415           echo 'read confirm'; \
1416           echo 'if [ "x$$confirm" != "xy" ]; then exit 0; fi'; \
1417           echo 'fi'; \
1418           $(AWK) -- '{print "addgroup --system",$$1}' doc/users/groups; \
1419           $(AWK) -- '{if (NF > 1) {print "adduser --system --ingroup",$$2,$$1} else {print "adduser --system",$$1}}' doc/users/users; \
1420           $(AWK) -- '{print "adduser",$$1,$$2}' doc/users/groupmemberships; \
1421         } > $@
1422         chmod +x $@
1423
1424 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1425         sed -f $(REPLACE_VARS_SED) < $< > $@
1426         chmod +x $@
1427
1428 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1429         sed -f $(REPLACE_VARS_SED) < $< > $@
1430         chmod +x $@
1431
1432 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1433         sed -f $(REPLACE_VARS_SED) < $< > $@
1434
1435 doc/examples/bash_completion: BC_ARGS = --compact
1436 doc/examples/bash_completion-debug: BC_ARGS =
1437
1438 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1439         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1440         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1441         daemons/ganeti-cleaner \
1442         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1443         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1444           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1445
1446 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1447         lib/build/shell_example_lexer.py \
1448         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1449         @echo "Checking $< for hardcoded paths..."
1450         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1451           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1452           exit 1; \
1453         fi
1454         set -e ; \
1455         trap 'echo auto-removing $@; rm $@' EXIT; \
1456         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1457         $(CHECK_MAN_REFERENCES) $@; \
1458         trap - EXIT
1459
1460 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1461         @test -n "$(PANDOC)" || \
1462           { echo 'pandoc' not found during configure; exit 1; }
1463         set -o pipefail -e; \
1464         trap 'echo auto-removing $@; rm $@' EXIT; \
1465         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1466           sed -e 's/\\@/@/g' > $@; \
1467         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1468         $(CHECK_MAN_DASHES) $@; \
1469         trap - EXIT
1470
1471 man/%.html.in: man/%.gen man/footer.rst
1472         @test -n "$(PANDOC)" || \
1473           { echo 'pandoc' not found during configure; exit 1; }
1474         set -o pipefail ; \
1475         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1476           sed -e 's/\\@/@/g' > $@
1477
1478 man/%: man/%.in  $(REPLACE_VARS_SED)
1479         sed -f $(REPLACE_VARS_SED) < $< > $@
1480
1481 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1482         sed -f $(REPLACE_VARS_SED) < $< > $@
1483
1484 vcs-version:
1485         if test -d .git; then \
1486           git describe > $@; \
1487         elif test ! -f $@ ; then \
1488           echo "Cannot auto-generate $@ file"; exit 1; \
1489         fi
1490
1491 .PHONY: clean-vcs-version
1492 clean-vcs-version:
1493         rm -f vcs-version
1494
1495 .PHONY: regen-vcs-version
1496 regen-vcs-version:
1497         @set -e; \
1498         cd $(srcdir); \
1499         if test -d .git; then \
1500           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1501           git describe > $$T; \
1502           if ! cmp --quiet $$T vcs-version; then \
1503             mv $$T vcs-version; \
1504           fi; \
1505         fi
1506
1507 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1508         vcs-version $(built_base_sources)
1509         set -e; \
1510         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1511         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1512
1513 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1514         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1515         lib/jstore.py $(RUN_IN_TEMPDIR) \
1516         $(CONVERT_CONSTANTS) $(built_base_sources) \
1517         | lib/_vcsversion.py
1518         set -e; \
1519         { cat $< ; \
1520           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1521         } > $@
1522
1523 src/Ganeti/Curl/Internal.hs: src/Ganeti/Curl/Internal.hsc | stamp-directories
1524         hsc2hs -o $@ $<
1525
1526 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1527         $(built_base_sources)
1528         set -e; \
1529         { cat $< ; \
1530           echo ; \
1531           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1532             echo "import $$name ()" ; \
1533           done ; \
1534         } > $@
1535
1536 lib/_autoconf.py: Makefile | stamp-directories
1537         set -e; \
1538         { echo '# This file is automatically generated, do not edit!'; \
1539           echo '#'; \
1540           echo ''; \
1541           echo '"""Build-time configuration for Ganeti.'; \
1542           echo '';\
1543           echo 'This file is autogenerated by the build process.'; \
1544           echo 'For any changes you need to re-run ./configure (and'; \
1545           echo 'not edit by hand).'; \
1546           echo ''; \
1547           echo '"""'; \
1548           echo ''; \
1549           echo '# pylint: disable=C0301,C0324'; \
1550           echo '# because this is autogenerated, we do not want'; \
1551           echo '# style warnings' ; \
1552           echo ''; \
1553           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1554           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1555           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1556           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1557           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1558           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1559           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1560           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1561           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1562           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1563           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1564           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1565           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1566           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1567           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1568           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1569           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1570           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1571           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1572           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1573           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1574           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1575           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1576           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1577           echo "KVM_PATH = '$(KVM_PATH)'"; \
1578           echo "IP_PATH = '$(IP_PATH)'"; \
1579           echo "SOCAT_PATH = '$(SOCAT)'"; \
1580           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1581           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1582           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1583           echo "TOOLSDIR = '$(toolsdir)'"; \
1584           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1585           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1586           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1587           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1588           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1589           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1590           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1591           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1592           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1593           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1594           echo "RAPI_USER = '$(RAPI_USER)'"; \
1595           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1596           echo "CONFD_USER = '$(CONFD_USER)'"; \
1597           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1598           echo "LUXID_USER = '$(LUXID_USER)'"; \
1599           echo "LUXID_GROUP = '$(LUXID_GROUP)'"; \
1600           echo "NODED_USER = '$(NODED_USER)'"; \
1601           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1602           echo "MOND_USER = '$(MOND_USER)'"; \
1603           echo "MOND_GROUP = '$(MOND_GROUP)'"; \
1604           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1605           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1606           echo "HTOOLS = True"; \
1607           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1608           echo "XEN_CMD = '$(XEN_CMD)'"; \
1609           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1610           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1611           echo "ENABLE_MOND = $(ENABLE_MOND)"; \
1612 ## Write dictionary with man page name as the key and the section number as the
1613 ## value
1614           echo "MAN_PAGES = {"; \
1615           for i in $(notdir $(man_MANS)); do \
1616             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1617           done; \
1618           echo "}"; \
1619         } > $@
1620
1621 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1622         set -e; \
1623         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1624         { echo '# This file is automatically generated, do not edit!'; \
1625           echo '#'; \
1626           echo ''; \
1627           echo '"""Build-time VCS version number for Ganeti.'; \
1628           echo '';\
1629           echo 'This file is autogenerated by the build process.'; \
1630           echo 'For any changes you need to re-run ./configure (and'; \
1631           echo 'not edit by hand).'; \
1632           echo ''; \
1633           echo '"""'; \
1634           echo ''; \
1635           echo '# pylint: disable=C0301,C0324'; \
1636           echo '# because this is autogenerated, we do not want'; \
1637           echo '# style warnings' ; \
1638           echo ''; \
1639           echo "VCS_VERSION = '$$VCSVER'"; \
1640         } > $@
1641
1642 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1643         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1644
1645 $(SHELL_ENV_INIT): Makefile stamp-directories
1646         set -e; \
1647         { echo '# Allow overriding for tests'; \
1648           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1649           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1650           echo; \
1651           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1652           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1653           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1654           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1655           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1656         } > $@
1657
1658 ## Writes sed script to replace placeholders with build-time values. The
1659 ## additional quotes after the first @ sign are necessary to stop configure
1660 ## from replacing those values as well.
1661 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1662         set -e; \
1663         { echo 's#@''PREFIX@#$(prefix)#g'; \
1664           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1665           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1666           echo 's#@''BINDIR@#$(bindir)#g'; \
1667           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1668           echo 's#@''LIBDIR@#$(libdir)#g'; \
1669           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1670           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1671           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1672           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1673           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1674           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1675           echo 's#@''RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1676           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1677           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1678           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1679           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1680           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1681           echo 's#@''GNTLUXIDUSER@#$(LUXID_USER)#g'; \
1682           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1683           echo 's#@''GNTMONDUSER@#$(MOND_USER)#g'; \
1684           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1685           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1686           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1687           echo 's#@''GNTNODEDGROUP@#$(NODED_GROUP)#g'; \
1688           echo 's#@''GNTLUXIDGROUP@#$(LUXID_GROUP)#g'; \
1689           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1690           echo 's#@''GNTMONDGROUP@#$(MOND_GROUP)#g'; \
1691           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1692           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1693           echo 's#@''CUSTOM_ENABLE_MOND@#$(ENABLE_MOND)#g'; \
1694           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1695           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1696           echo; \
1697           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1698           echo '  r $(SHELL_ENV_INIT)'; \
1699           echo '  d'; \
1700           echo '}'; \
1701         } > $@
1702
1703 # Using deferred evaluation
1704 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1705 daemons/ganeti-watcher: MODULE = ganeti.watcher
1706 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1707 tools/burnin: MODULE = ganeti.tools.burnin
1708 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1709 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1710 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1711 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1712 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1713
1714 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1715         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1716         set -e; \
1717         { echo '#!/usr/bin/python'; \
1718           echo '# This file is automatically generated, do not edit!'; \
1719           echo "# Edit $(MODULE) instead."; \
1720           echo; \
1721           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1722           echo; \
1723           echo '# pylint: disable=C0103'; \
1724           echo '# C0103: Invalid name'; \
1725           echo; \
1726           echo 'import sys'; \
1727           echo 'import $(MODULE) as main'; \
1728           echo; \
1729           echo '# Temporarily alias commands until bash completion'; \
1730           echo '# generator is changed'; \
1731           echo 'if hasattr(main, "commands"):'; \
1732           echo '  commands = main.commands # pylint: disable=E1101'; \
1733           echo 'if hasattr(main, "aliases"):'; \
1734           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1735           echo; \
1736           echo 'if __name__ == "__main__":'; \
1737           echo '  sys.exit(main.Main())'; \
1738         } > $@
1739         chmod u+x $@
1740
1741 $(HS_BUILT_TEST_HELPERS): Makefile
1742         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1743         set -e; \
1744         { echo '#!/bin/sh'; \
1745           echo '# This file is automatically generated, do not edit!'; \
1746           echo "# Edit Makefile.am instead."; \
1747           echo; \
1748           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1749         } > $@
1750         chmod u+x $@
1751
1752 stamp-directories: Makefile
1753         $(MAKE) $(AM_MAKEFLAGS) ganeti
1754         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1755         touch $@
1756
1757 # We need to create symlinks because "make distcheck" will not install Python
1758 # files when building.
1759 stamp-srclinks: Makefile | stamp-directories
1760         set -e; \
1761         for i in $(srclink_files); do \
1762           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1763             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1764           fi; \
1765         done
1766         touch $@
1767
1768 .PHONY: ganeti
1769 ganeti:
1770         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1771
1772 .PHONY: check-dirs
1773 check-dirs: $(GENERATED_FILES)
1774         @set -e; \
1775         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1776           error=; \
1777           while read dir; do \
1778             case "$$dir" in \
1779               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1780               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1781             esac; \
1782           done; \
1783           for dir in $(DIRS); do \
1784             if ! test -d "$$dir"; then \
1785               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1786               error=1; \
1787             fi \
1788           done; \
1789           test -z "$$error"; \
1790         }
1791
1792 .PHONY: check-local
1793 check-local: check-dirs $(GENERATED_FILES)
1794         $(CHECK_PYTHON_CODE) $(check_python_code)
1795         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1796         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1797         RELEASE=$(PACKAGE_VERSION) $(CHECK_NEWS) < $(top_srcdir)/NEWS
1798         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1799         error= ; \
1800         if [ "x`echo $(VERSION_SUFFIX)|grep 'alpha'`" == "x" ]; then \
1801           expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1802           if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1803             echo "Incorrect version in README, expected $$expver" >&2; \
1804             error=1; \
1805           fi; \
1806           for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1807               doc/security.rst; do \
1808             if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1809               "Documents Ganeti version $$expver"; then \
1810               echo "Incorrect version in $$file, expected $$expver" >&2; \
1811               error=1; \
1812             fi; \
1813           done; \
1814           if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1815             echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1816             error=1; \
1817           fi; \
1818           if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1819             ".. Last updated for Ganeti $$expver"; then \
1820             echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1821             error=1; \
1822           fi; \
1823         fi; \
1824         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1825           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1826             echo "Longest line in $$file is longer than 80 characters" >&2; \
1827             error=1; \
1828           fi; \
1829         done; \
1830         test -z "$$error"
1831
1832 .PHONY: hs-tests
1833 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1834         @rm -f htest.tix
1835         ./test/hs/htest
1836
1837 .PHONY: hs-shell
1838 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1839         @rm -f hpc-htools.tix hpc-mon-collector.tix
1840         HBINARY="./test/hs/hpc-htools" ./test/hs/offline-test.sh
1841
1842 .PHONY: hs-check
1843 hs-check: hs-tests hs-shell
1844
1845 # E111: indentation is not a multiple of four
1846 # E121: continuation line indentation is not a multiple of four
1847 #       (since our indent level is not 4)
1848 # E125: continuation line does not distinguish itself from next logical line
1849 #       (since our indent level is not 4)
1850 # E127: continuation line over-indented for visual indent
1851 #       (since our indent level is not 4)
1852 # note: do NOT add E128 here; it's a valid style error in most cases!
1853 # I've seen real errors, but also some cases were we indent wrongly
1854 # due to line length; try to rework the cases where it is triggered,
1855 # instead of silencing it
1856 # E261: at least two spaces before inline comment
1857 # E501: line too long (80 characters)
1858 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1859
1860 # For excluding pep8 expects filenames only, not whole paths
1861 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1862
1863 LINT_TARGETS = pylint pylint-qa
1864 if HAS_PEP8
1865 LINT_TARGETS += pep8
1866 endif
1867 if HAS_HLINT
1868 LINT_TARGETS += hlint
1869 endif
1870
1871 .PHONY: lint
1872 lint: $(LINT_TARGETS)
1873
1874 .PHONY: pylint
1875 pylint: $(GENERATED_FILES)
1876         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1877         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1878
1879 .PHONY: pylint-qa
1880 pylint-qa: $(GENERATED_FILES)
1881         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1882         cd $(top_srcdir)/qa && \
1883           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1884           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1885
1886 .PHONY: pep8
1887 pep8: $(GENERATED_FILES)
1888         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1889         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1890           --repeat $(pep8_python_code)
1891
1892 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1893 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1894 .PHONY: hlint
1895 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1896         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1897         @rm -f doc/hs-lint.html
1898         if tty -s; then C="-c"; else C=""; fi; \
1899         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1900           --ignore "Use first" \
1901           --ignore "Use &&&" \
1902           --ignore "Use void" \
1903           --ignore "Reduce duplication" \
1904           --hint src/lint-hints \
1905           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1906         @if [ ! -f doc/hs-lint.html ]; then \
1907           echo "All good" > doc/hs-lint.html; \
1908         fi
1909
1910 # a dist hook rule for updating the vcs-version file; this is
1911 # hardcoded due to where it needs to build the file...
1912 dist-hook:
1913         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1914         rm -f $(top_distdir)/vcs-version
1915         cp -p $(srcdir)/vcs-version $(top_distdir)
1916
1917 # a distcheck hook rule for catching revision control directories
1918 distcheck-hook:
1919         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1920           echo "Found revision control files in final archive." 1>&2; \
1921           exit 1; \
1922         fi
1923         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1924           echo "Found Python byte code in final archive." 1>&2; \
1925           exit 1; \
1926         fi
1927         if find $(top_distdir) -name '*~' | grep .; then \
1928           echo "Found backup files in final archive." 1>&2; \
1929           exit 1; \
1930         fi
1931 # Empty files or directories should not be distributed. They can cause
1932 # unnecessary warnings for packagers. Directories used by automake during
1933 # distcheck must be excluded.
1934         if find $(top_distdir) -empty -and -not \( \
1935             -path $(top_distdir)/_build -or \
1936             -path $(top_distdir)/_inst \) | grep .; then \
1937           echo "Found empty files or directories in final archive." 1>&2; \
1938           exit 1; \
1939         fi
1940         if test -e $(top_distdir)/doc/man-html; then \
1941           echo "Found documentation including man pages in final archive" >&2; \
1942           exit 1; \
1943         fi
1944
1945 # Backwards compatible distcheck-release target
1946 distcheck-release: distcheck
1947
1948 distrebuildcheck: dist
1949         set -e; \
1950         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1951         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1952         cd $$builddir; \
1953         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1954         cd $(distdir); \
1955         ./configure; \
1956         $(MAKE) maintainer-clean; \
1957         cp $(abs_srcdir)/vcs-version .; \
1958         ./configure; \
1959         $(MAKE) $(AM_MAKEFLAGS)
1960
1961 dist-release: dist
1962         set -e; \
1963         for i in $(DIST_ARCHIVES); do \
1964           echo -n "Checking $$i ... "; \
1965           autotools/check-tar < $$i; \
1966           echo OK; \
1967         done
1968
1969 install-exec-local:
1970         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1971           "$(DESTDIR)${localstatedir}/log/ganeti" \
1972           "$(DESTDIR)${localstatedir}/run/ganeti"
1973
1974 .PHONY: apidoc
1975 if WANT_HSAPIDOC
1976 apidoc: py-apidoc hs-apidoc
1977 else
1978 apidoc: py-apidoc
1979 endif
1980
1981 .PHONY: py-apidoc
1982 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1983         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
1984         $(RUN_IN_TEMPDIR) epydoc -v \
1985           --conf $(CURDIR)/epydoc.conf \
1986           --output $(CURDIR)/$(APIDOC_PY_DIR)
1987
1988 .PHONY: hs-apidoc
1989 hs-apidoc: $(APIDOC_HS_DIR)/index.html
1990
1991 $(APIDOC_HS_DIR)/index.html: $(HS_LIBTESTBUILT_SRCS) Makefile
1992         @test -n "$(HSCOLOUR)" || \
1993             { echo 'HsColour' not found during configure; exit 1; }
1994         @test -n "$(HADDOCK)" || \
1995             { echo 'haddock' not found during configure; exit 1; }
1996         rm -rf $(APIDOC_HS_DIR)/*
1997         for i in $(ALL_APIDOC_HS_DIRS); do \
1998           @mkdir_p@ $$i; \
1999           $(HSCOLOUR) -print-css > $$i/hscolour.css; \
2000         done
2001         set -e ; \
2002         export LC_ALL=en_US.UTF-8; \
2003         OPTGHC="--optghc=-isrc --optghc=-itest/hs"; \
2004         if [ "$(HS_PARALLEL3)" ]; \
2005         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
2006         fi; \
2007         if [ "$(HS_REGEX_PCRE)" ]; \
2008         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
2009         fi; \
2010         for file in $(HS_LIBTESTBUILT_SRCS); do \
2011           f_nosrc=$${file##src/}; \
2012           f_notst=$${f_nosrc##test/hs/}; \
2013           f_html=$${f_notst%%.hs}.html; \
2014           $(HSCOLOUR) -css -anchor $$file > $(APIDOC_HS_DIR)/$$f_html ; \
2015         done ; \
2016         $(HADDOCK) --odir $(APIDOC_HS_DIR) --html --ignore-all-exports -w \
2017           -t ganeti -p src/haddock-prologue \
2018           --source-module="%{MODULE/.//}.html" \
2019           --source-entity="%{MODULE/.//}.html#%{NAME}" \
2020           $$OPTGHC \
2021           $(HS_LIBTESTBUILT_SRCS)
2022
2023 .PHONY: TAGS
2024 TAGS: $(GENERATED_FILES)
2025         rm -f TAGS
2026         $(GHC) -e ":etags" -v0 \
2027           $(filter-out -O -Werror,$(HFLAGS)) \
2028           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
2029           $(HS_LIBTEST_SRCS)
2030         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
2031           -path './daemons/ganeti-*' -o -path './tools/*' -o \
2032           -path './qa/*.py' | \
2033           etags -l python -a -
2034
2035 .PHONY: coverage
2036
2037 COVERAGE_TESTS=
2038 if WANT_HTOOLS
2039 COVERAGE_TESTS += hs-coverage
2040 endif
2041 if PY_UNIT
2042 COVERAGE_TESTS += py-coverage
2043 endif
2044
2045 coverage: $(COVERAGE_TESTS)
2046
2047 .PHONY: py-coverage
2048 py-coverage: $(GENERATED_FILES) $(python_tests)
2049         @test -n "$(PYCOVERAGE)" || \
2050             { echo 'python-coverage' not found during configure; exit 1; }
2051         set -e; \
2052         COVERAGE=$(PYCOVERAGE) \
2053         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
2054         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
2055         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
2056         $(PLAIN_TESTS_ENVIRONMENT) \
2057         $(abs_top_srcdir)/autotools/gen-py-coverage \
2058         $(python_tests)
2059
2060 .PHONY: hs-coverage
2061 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
2062         rm -f *.tix
2063         $(MAKE) $(AM_MAKEFLAGS) hs-check
2064         @mkdir_p@ $(COVERAGE_HS_DIR)
2065         hpc sum --union $(HPCEXCL) \
2066           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
2067         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
2068         hpc report coverage-hs.tix
2069         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
2070
2071 # Special "kind-of-QA" target for htools, needs special setup (all
2072 # tools compiled with -fhpc)
2073 .PHONY: live-test
2074 live-test: all
2075         set -e ; \
2076         cd src; \
2077         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
2078         rm -f *.tix *.mix; \
2079         ./live-test.sh; \
2080         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
2081           --output=live-test.tix ; \
2082         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
2083         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
2084           --srcdir=.. $(HPCEXCL) ; \
2085         hpc report --srcdir=.. live-test $(HPCEXCL)
2086
2087 commit-check: autotools-check distcheck lint apidoc
2088
2089 autotools-check:
2090         TESTDATA_DIR=./test/data shelltest $(SHELLTESTARGS) \
2091   $(abs_top_srcdir)/test/autotools/*-*.test \
2092   -- --hide-successes
2093
2094 .PHONY: gitignore-check
2095 gitignore-check:
2096         @if [ -n "`git status --short`" ]; then \
2097           echo "Git status is not clean!" 1>&2 ; \
2098           git status --short; \
2099           exit 1; \
2100         fi
2101
2102 # target to rebuild all man pages (both groff and html output)
2103 .PHONY: man
2104 man: $(man_MANS) $(manhtml)
2105
2106 # Target that builds all binaries (including those that are not
2107 # rebuilt except when running the tests)
2108 .PHONY: really-all
2109 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
2110
2111 # we don't need the ancient implicit rules:
2112 %: %,v
2113 %: RCS/%,v
2114 %: RCS/%
2115 %: s.%
2116 %: SCCS/s.%
2117
2118 -include ./Makefile.local
2119
2120 # vim: set noet :